-- a filtered list of all the items that should be shown
local GNFP_GuildNewsTable = {};

local AddonLoadedHook = CreateFrame("Frame")
AddonLoadedHook:RegisterEvent("ADDON_LOADED");
AddonLoadedHook:SetScript("OnEvent", function(self, event, AddonName)
	if AddonName == "Blizzard_GuildUI" then
		GNFP_DB = GNFP_DB or {};
		
		GBFP_ReplaceBlizzardFunctions()
		GNFP_SetupOptions()
	end
end)

function GNFP_SetupOptions()
	--GuildNewsFiltersFrame
	
-- Make the frame larger to fit in the options
	GuildNewsFiltersFrame:SetHeight(GuildNewsFiltersFrame:GetHeight()+100)
	
	local backdrop = {
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",  -- path to the background texture
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",  -- path to the border texture
		tile = false,    -- true to repeat the background texture to fill the frame, false to scale it
		tileSize = 32,  -- size (width or height) of the square repeating background tiles (in pixels)
		edgeSize = 10,  -- thickness of edge segments and square size of edge corners (in pixels)
		insets = {    -- distance from the edges of the frame to those of the background texture (in pixels)
			left = 4,
			right = 4,
			top = 4,
			bottom = 4
		}
	}
	
-- Min Item Level Frame (begin) ------------------------------------------------------------------------------------------------------
	GNFP_MinItemLevel_Frame=CreateFrame("FRAME","GNFP_MinItemLevel_Frame",GuildNewsFiltersFrame);
	GNFP_MinItemLevel_Frame:SetWidth(50); 
	GNFP_MinItemLevel_Frame:SetHeight(20);
	GNFP_MinItemLevel_Frame:SetPoint("TopLeft",GuildNewsFiltersFrame,"TopLeft",150, -220);
	GNFP_MinItemLevel_Frame:SetBackdrop(backdrop)
-- Min Item Level Frame (end) ------------------------------------------------------------------------------------------------------

-- Min Item Level Text (begin) ------------------------------------------------------------------------------------------------------
	GNFP_MinItemLevel_Text = GNFP_MinItemLevel_Frame:CreateFontString("WPug_DifferentTypes_Frame_Text","ARTWORK","GameFontNormal");
	GNFP_MinItemLevel_Text:SetPoint("Right",GNFP_MinItemLevel_Frame,"Left",-5,0);
	GNFP_MinItemLevel_Text:SetJustifyH("Right");
	GNFP_MinItemLevel_Text:SetText("|cffffffff" .. GNF_MIN_ITEM_LEVEL .. ":");
-- Min Item Level Text (end) ------------------------------------------------------------------------------------------------------

-- Min Item Level CheckBox (begin) ------------------------------------------------------------------------------------------------------
	GNFP_MinItemLevel_CheckButton = CreateFrame("CheckButton", "GNFP_MinItemLevel_CheckButton", GuildNewsFiltersFrame, "UICheckButtonTemplate");
	GNFP_MinItemLevel_CheckButton:SetWidth(23);
	GNFP_MinItemLevel_CheckButton:SetHeight(23);
	GNFP_MinItemLevel_CheckButton:SetPoint("TopLeft",GuildNewsFiltersFrame,"TopLeft",25, -220);
	GNFP_MinItemLevel_CheckButton:SetText("");
	GNFP_MinItemLevel_CheckButton:SetChecked(GNFP_DB["GNFP_MinItemLevel_CheckButton"])
	GNFP_MinItemLevel_CheckButton:SetScript("OnClick", function(self)
		GNFP_DB[self:GetName()] = self:GetChecked();
		GuildNewsSort(0);
	end)
-- Min Item Level CheckBox (end) ------------------------------------------------------------------------------------------------------
	
-- Min Item Level (begin) ------------------------------------------------------------------------------------------------------
	GNFP_MinItemLevel_Box = CreateFrame("EditBox", "GNFP_MinItemLevel_Box", GuildNewsFiltersFrame, InputBoxTemplate )
	GNFP_MinItemLevel_Box:SetFont("Fonts\\FRIZQT__.TTF", 12)
	GNFP_MinItemLevel_Box:SetAutoFocus(false)
	GNFP_MinItemLevel_Box:SetNumeric(true)
	GNFP_MinItemLevel_Box:SetWidth(460)
	GNFP_MinItemLevel_Box:SetHeight(12) -- Set these to whatever height/width is needed 
	GNFP_MinItemLevel_Box:SetPoint("Left", GNFP_MinItemLevel_Frame, "Left", 8, 0)
	
	GNFP_MinItemLevel_Box:SetText(GNFP_DB["GNFP_MinItemLevel_Box"] or "354")
	GNFP_MinItemLevel_Box:SetScript("OnEditFocusLost",	function(self)
													if GNFP_MinItemLevel_Box:GetText() == "" then
														GNFP_MinItemLevel_Box:SetText(0)
													end
													
													GNFP_DB[self:GetName()] = self:GetText();
													GuildNewsSort(0);
												end)
	GNFP_MinItemLevel_Box:SetScript("OnEnterPressed",	function(self) self:ClearFocus() 	end)
	GNFP_MinItemLevel_Box:SetScript("OnEscapePressed",	function(self) self:ClearFocus()	end)
-- Min Item Level (end) ------------------------------------------------------------------------------------------------------



-- Ignored Words Frame (begin) ------------------------------------------------------------------------------------------------------
	GNFP_IgnoredWords_Frame=CreateFrame("FRAME","GNFP_IgnoredWords_Frame",GuildNewsFiltersFrame);
	GNFP_IgnoredWords_Frame:SetWidth(90); 
	GNFP_IgnoredWords_Frame:SetHeight(20);
	GNFP_IgnoredWords_Frame:SetPoint("TopLeft",GuildNewsFiltersFrame,"TopLeft",150, -240);
	GNFP_IgnoredWords_Frame:SetBackdrop(backdrop)
-- Ignored Words Frame (end) ------------------------------------------------------------------------------------------------------

-- Ignored Words Text (begin) ------------------------------------------------------------------------------------------------------
	GNFP_IgnoredWords_Text = GNFP_IgnoredWords_Frame:CreateFontString("WPug_DifferentTypes_Frame_Text","ARTWORK","GameFontNormal");
	GNFP_IgnoredWords_Text:SetPoint("Right",GNFP_IgnoredWords_Frame,"Left",-5,0);
	GNFP_IgnoredWords_Text:SetJustifyH("Right");
	GNFP_IgnoredWords_Text:SetText("|cffffffff" .. GNF_IGNORED_WORDS .. ":");
	
	GNFP_IgnoredWords_Text2 = GNFP_IgnoredWords_Frame:CreateFontString("WPug_DifferentTypes_Frame_Text","ARTWORK","GameFontNormal");
	GNFP_IgnoredWords_Text2:SetPoint("TopLeft",GNFP_IgnoredWords_Text,"BottomLeft",-25,-5);
	GNFP_IgnoredWords_Text2:SetJustifyH("Right");
	GNFP_IgnoredWords_Text2:SetText("|cff9f9f9f(".. GNF_IGNORED_WORD_INFO ..")");
-- Ignored Words Text (end) ------------------------------------------------------------------------------------------------------

-- Ignored Words CheckBox (begin) ------------------------------------------------------------------------------------------------------
	GNFP_IgnoredWords_CheckButton = CreateFrame("CheckButton", "GNFP_IgnoredWords_CheckButton", GuildNewsFiltersFrame, "UICheckButtonTemplate");
	GNFP_IgnoredWords_CheckButton:SetWidth(23);
	GNFP_IgnoredWords_CheckButton:SetHeight(23);
	GNFP_IgnoredWords_CheckButton:SetPoint("TopLeft",GuildNewsFiltersFrame,"TopLeft",25, -240);
	GNFP_IgnoredWords_CheckButton:SetText("");
	GNFP_IgnoredWords_CheckButton:SetChecked(GNFP_DB["GNFP_IgnoredWords_CheckButton"])
	GNFP_IgnoredWords_CheckButton:SetScript("OnClick", function(self)
		GNFP_DB[self:GetName()] = self:GetChecked();
		GuildNewsSort(0);
	end)
-- Ignored Words CheckBox (end) ------------------------------------------------------------------------------------------------------
	
-- Ignored Words (begin) ------------------------------------------------------------------------------------------------------
	GNFP_IgnoredWords_Box = CreateFrame("EditBox", "GNFP_IgnoredWords_Box", GuildNewsFiltersFrame, InputBoxTemplate )
	GNFP_IgnoredWords_Box:SetFont("Fonts\\FRIZQT__.TTF", 12)
	GNFP_IgnoredWords_Box:SetAutoFocus(false)
	GNFP_IgnoredWords_Box:SetWidth(80)
	GNFP_IgnoredWords_Box:SetHeight(12) -- Set these to whatever height/width is needed 
	GNFP_IgnoredWords_Box:SetPoint("Left", GNFP_IgnoredWords_Frame, "Left", 8, 0)
	
	GNFP_IgnoredWords_Box:SetText(GNFP_DB["GNFP_IgnoredWords_Box"] or "")
	GNFP_IgnoredWords_Box:SetScript("OnEditFocusLost",	function(self)
													GNFP_DB[self:GetName()] = self:GetText();
													GuildNewsSort(0);
												end)
	GNFP_IgnoredWords_Box:SetScript("OnEnterPressed",	function(self) self:ClearFocus() 	end)
	GNFP_IgnoredWords_Box:SetScript("OnEscapePressed",	function(self) self:ClearFocus()	end)
-- Ignored Words (end) ------------------------------------------------------------------------------------------------------
end

function GNFP_IgnoredWordsFilter(itemName)
	-- reset the filter out flag
	local GNFP_FilterFlag = true;

	if GNFP_IgnoredWords_Box:GetText() ~= "" then
		local SearchText = GNFP_IgnoredWords_Box:GetText();
		
		while SearchText ~= nil do
			if SearchText ~= nil then
				local SearchTerm, RestOfText = strsplit(",", SearchText, 2)
				SearchText = RestOfText;
				
				if itemName ~= nil and SearchTerm ~= nil then
					if strfind(strlower(itemName), strlower(SearchTerm)) then
						--set the filter out flag for this id to false (it is not allowed)
						GNFP_FilterFlag = false;
					end
				end
			end
		end
	end
	
	return GNFP_FilterFlag
end

function GBFP_ReplaceBlizzardFunctions()
	local orig_GetGuildNewsInfo = GetGuildNewsInfo;
	local orig_GetNumGuildNews  = GetNumGuildNews;
	local orig_GuildNewsButton_OnClick = GuildNewsButton_OnClick;
	
	function GetNumGuildNews()
		local j = 0;
		GNFP_GuildNewsTable = {};
		
		for i=1,orig_GetNumGuildNews() do 
			local isSticky, isHeader, newsType, text1, text2, id, data, data2, weekday, day, month, year = orig_GetGuildNewsInfo(i);
		
			if newsType == 3 or newsType == 4 or newsType == 5 then
				
				local ItemStringAllowed = GNFP_IgnoredWordsFilter(text2);
				
				local ItemIsAllowed = true;
				
				-- word filter
				if GNFP_IgnoredWords_CheckButton:GetChecked() and ItemIsAllowed  then
					if not ItemStringAllowed then
						ItemIsAllowed = false;
					end
				end
				
				--item level filter
				if GNFP_MinItemLevel_CheckButton:GetChecked() and ItemIsAllowed and text2 ~= nil then
					--Get the item level from the item id
					local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(text2);
					iLevel = iLevel or 0;
					
					-- get the compare value from the box
					local itemLevelCompare = tonumber(GNFP_MinItemLevel_Box:GetText()) or 0;
					
					--check if it should be filtered
					if iLevel < itemLevelCompare then
						ItemIsAllowed = false;
					end
				end
				
				--If the item is allowed then add it to the directory
				if ItemIsAllowed then
					j = j + 1;
					GNFP_GuildNewsTable[j] = i;
				end
			else
				j = j + 1;
				GNFP_GuildNewsTable[j] = i;
			end
		end
		
		return j;
	end
	
	function GetGuildNewsInfo(index)		
		local isSticky, isHeader, newsType, text1, text2, id, data, data2, weekday, day, month, year = orig_GetGuildNewsInfo(GNFP_GuildNewsTable[index]);

		if newsType == 3 or newsType == 4 or newsType == 5 and text2 ~= nil then

			local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(text2);
			iLevel = iLevel or 0;

			text1 = "(|cFFF2C319" .. iLevel .. "|r) " .. text1

		end
		
		return isSticky, isHeader, newsType, text1, text2, id, data, data2, weekday, day, month, year
		--return orig_GetGuildNewsInfo(GNFP_GuildNewsTable[index])
	end
	
	
	
	function GuildNewsButton_OnClick(self, button)
		if button == "LeftButton" then
			if IsControlKeyDown() or IsShiftKeyDown() then				
				local isSticky, isHeader, newsType, text1, text2, id, data, data2, weekday, day, month, year = GetGuildNewsInfo(self.index);
				
				if newsType == 3 or newsType == 4 or newsType == 5 then
					local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(id);
					
					if IsShiftKeyDown() then
						ChatEdit_InsertLink(itemLink) 
					elseif IsControlKeyDown() then
						DressUpItemLink(itemLink)
					end
				end
			end
		end
		
		orig_GuildNewsButton_OnClick(self, button)
    end
end
